//+------------------------------------------------------------------+
//|                                       Blessing Martingale_v7.mq4 |
//| Idea by rifo                                                     |
//| Programmed by Fikko                                              |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Rifo & Fikko"
#property link      ""

//---- input parameters

extern bool    OpenNew=true;        // Set to false for closing grid slowly
extern string  Settings="------------------------";
extern double  Levels = 8;          // Level
extern double  Multiplier=2;        // Quantity of Multiplying
extern int     GridPip=20;          // Grid Separate
extern int     TakeProfit=20;       // Take Profit
extern int     TakeProfitLevel1=20; // Take Profit for Level 1
extern int     Slippage=3;          // Slippage
extern string  Security="------------------------";
extern bool    UseStopLoss=false;   // Use StopLoss
extern double  StopLoss=1000;       // StopLoss only for protection
extern string  MoneyManagement="------------------------";
extern bool    MM=true;
extern double  Lots=0.1;
extern int     LotsDigit=1;
extern int     EquityFactor=1000000;
extern double  MaxLot=100;
extern double  MinLot=0.1;
extern string  MagicNumbers="------------------------";
extern int     MagicLong=800111;
extern int     MagicShort=800222;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

   int ticket1=0;    
   int cmd = 2; double Lot; double price; double stoploss=0; double takeprofit; color colour;
   int BuyTicket = 0; int SellTicket = 0;
   if (MM==true) Lot = NormalizeDouble((AccountEquity()/EquityFactor),LotsDigit); else Lot = Lots;
   if (Lot > MaxLot) Lot = MaxLot;
   if (Lot < MinLot) Lot = MinLot;
   
   BuyTicket  = FixTakeProfit(MagicLong,0);
   int BuyQty = CalculateBuy();

   if(BuyQty < Levels)
   {
      CleanAllOpens(MagicLong,OP_BUY,Slippage);
      CleanAllPendings(MagicLong,OP_BUYLIMIT);
      
      cmd = OP_BUY; price = Ask; colour = Green; takeprofit = Ask +GridPip*Point;
      if(UseStopLoss == true) stoploss = Ask - StopLoss*Point;
      if(OpenNew) {
        ticket1=OpenOrder(cmd, Lot, price, Slippage, stoploss,Ask + TakeProfitLevel1*Point, MagicLong, colour);
        if (ticket1 == 0) return(0);
        SetPendingOrders(OP_BUYLIMIT,Lot,price,Slippage,StopLoss,TakeProfit,MagicLong,Levels);
      }
      return(0);
   }

   SellTicket  = FixTakeProfit(MagicShort,1);
   int SellQty = CalculateSell();

   if(SellQty < Levels)
   {
      CleanAllOpens(MagicShort,OP_SELL,Slippage);
      CleanAllPendings(MagicShort,OP_SELLLIMIT);
      
      cmd = OP_SELL; price = Bid; colour = Red; takeprofit = Bid - GridPip*Point; 
      if(UseStopLoss == true) stoploss = Bid + StopLoss*Point; 
      if(OpenNew) {      
        ticket1=OpenOrder(cmd, Lot, price, Slippage, stoploss, Bid - TakeProfitLevel1*Point, MagicShort, colour);
        if (ticket1 == 0) return(0);
        SetPendingOrders(OP_SELLLIMIT,Lot,price,Slippage,(-StopLoss),(-TakeProfit),MagicShort,Levels);
      }
      return(0);
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+

int OpenOrder(int cmd, double Lot, double price, int slippage, double stoploss, double takeprofit, int magic, color colour)
{
   RefreshRates();
   while(IsTradeAllowed() == false) DoNothing();
   int ticket = OrderSend(Symbol(), cmd, Lot, price, slippage, stoploss, takeprofit, NULL, magic, 0, colour);
   if(ticket < 0)
   {
      Print(price," == ",stoploss);
      Alert("!!! Error opening order !!! ", GetLastError());
      ticket = 0;
   }
   return(ticket);
}

//+-------------------------------------------------------

int FixTakeProfit(int magic, int cmd)
{
   int ticket = 0; int i;
   datetime time = 0;
   for(i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType() == cmd)
      {
         if(OrderOpenTime() > time) { time = OrderOpenTime();ticket = OrderTicket(); }
      }
   }
   
   if(ticket != 0)
   {
      OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
      double takeprofit = OrderTakeProfit();
   
      for(i=0;i<OrdersTotal();i++)
      {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType() == cmd)
         {
            if(OrderTakeProfit() != takeprofit) 
            { 
               while(IsTradeAllowed() == false) DoNothing();
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),takeprofit,0,Yellow); 
            }
         }
      }
   }
   
   return(ticket);
}   
//+------------------------------------------------------

void CleanAllPendings(int magic,int cmd)
{   
      for(int i=OrdersTotal()-1;i>=0;i--)
      {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType() == cmd)
         {
            int ticket = OrderTicket();
            while(IsTradeAllowed() == false) DoNothing();
            OrderDelete(ticket,CLR_NONE);
         }
      }
}

//+------------------------------------------------------

void CleanAllOpens(int magic,int cmd, int slippage)
{   
      for(int i=OrdersTotal()-1;i>=0;i--)
      {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType() == cmd)
         {
            int ticket = OrderTicket();
            while(IsTradeAllowed() == false) DoNothing();
            if (OrderType() == OP_BUY) {
              OrderClose(ticket,OrderLots(), Bid, slippage,CLR_NONE);
            } else {
              OrderClose(ticket,OrderLots(), Ask, slippage, CLR_NONE);
            }
         }
      }
}


//+-----------------------------------------------------

void SetPendingOrders(int cmd,double Lot,double price,int slippage,double stoploss,int PS,int magic, int levels)
{
   double sl = 0;
   for(int i=0;i<levels-1;i++)
   {
      while(IsTradeAllowed() == false) DoNothing();
      if (UseStopLoss) { sl = price-((i+1)*PS*Point+stoploss*Point); } else { sl = 0; }
      OpenOrder(cmd,NormalizeDouble(Lot*MathPow(Multiplier,i),LotsDigit),price-(i+1)*PS*Point,slippage,sl,price-i*PS*Point,magic,CLR_NONE);
   }
   return(0);
}

//+-----------------------------------------------------

void DoNothing() {
}

//+-----------------------------------------------------
int CalculateBuy() {
int cal=0;

      for(int i=OrdersTotal()-1;i>=0;i--)
      {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicLong && (OrderType() == OP_BUY || OrderType() == OP_BUYLIMIT))
         {
           cal = cal + 1;
         }
      }
      return(cal);
}
//+-----------------------------------------------------
int CalculateSell() {
int cal=0;

      for(int i=OrdersTotal()-1;i>=0;i--)
      {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicShort && (OrderType() == OP_SELL || OrderType() == OP_SELLLIMIT))
         {
           cal = cal + 1;
         }
      }
      return(cal);
}